/*
 * 21. Fejezet
 * 4.feladat: Nyomgombok megszaktsos kezelse, pergsmentests szoftveresen
 *
 * A PA0,1,2 lbakon lev hrom LED egy 3 bites szmll llapott tkrzi.
 * A PD2(INT0) s PD3(INT1) lbakon lev nyomgombbal lehet hozzadni, vagy elvenni
 * a szmll rtkbl. A gombok felengedsre (felfut lre) megszaktst generlnak.
 * Timer1 perifrit a pergsmentestsre hasznljuk.
 */

#include "../Headers/main.h"

volatile uint8_t cntr = 0;

// + gomb megszaktsa
ISR(INT0_vect)
{
	//Ha mg nem rte el a maximumot a szmll
	if (cntr < 7)
	{
		//akkor nvelem
		cntr++;
		
		//Timer1 szmll nullzsa
		TCNT1 = 0;
		//Timer1 overflow  interrupt engedlyezs
		sbi(TIMSK, TOIE1);

		//INTR0 interrupt tiltsa
		cbi(GICR, INTF0);
	}
}

// - gomb megszaktsa
ISR(INT1_vect)
{
	//Ha mg nem rte el a minimumot a szmll
	if (cntr > 0)
	{
		//akkor cskkentem
		cntr--;
		
		//Timer1 szmll nullzsa
		TCNT1 = 0;
		//Timer1 overflow  interrupt engedlyezs
		sbi(TIMSK, TOIE1);

		//INTR1 interrupt tiltsa
		cbi(GICR, INTF1);
	}
}

//Timer1 tlcsorduls megszakts
ISR(TIMER1_OVF_vect)
{
	//External interruptok engedlyezse, 67.oldal
	sbi(GICR, INTF0);
	sbi(GICR, INTF1);

	//External interrupt flagek trlse, 68.oldal
	cbi(GIFR, INTF0);
	cbi(GIFR, INTF1);

	//Timer1 overflow interrupt tiltsa
	cbi(TIMSK, TOIE1);
}


int main(void)
{
	//IO inicializlsa
	IOInit();
	//Timer1 inicializlsa
	TimerInit();

	//Vgtelen ciklus
	while (1)
	{
		//LED-ek kigyjtsa a szmllnak megfelelen
		PORTA = cntr;
	}

	return (0);
}
